// $id Javascript portion for the XMPP NODE MUC
var ROSTERWINOPTS = "top=25,width=375,height=450,location=0,scrollbars=1,resizable=1,status=0";
var xcpass = '';

$(document).ready(function() {
  $('.xmpp_node_muc a').click(function(e) {
    var nid = $(this).attr('nid');
    var url = $(this).attr('url');
    var attribute = $(this);
    $.get(url + '/' + nid, function(result) { eval(result); });
    return false;
  });
});

/**
 * @param gid
 */
function xmpp_node_muc_online_users_toggle(gid) {
  var name = '#xmpp_node_muc_online_' + gid + ' div#xmpp_node_muc_online_show_' + gid + ' a';
  var stoggle = '#xmpp_node_muc_online_' + gid + ' div#xmpp_node_muc_online_users_' + gid;
  var text = $(name).html();
  $(stoggle).slideToggle();
  if (text == 'Show') {
    $(name).html('Hide');
  } else {
    $(name).html('Show');
  }
}

/**
 * @param gid
 */
function xmpp_node_muc_activity_msgs_toggle(gid) {
  var name = '#xmpp_node_muc_activity_' + gid + ' div#xmpp_node_muc_activity_show_' + gid + ' a';
  var logname = '#xmpp_node_muc_activity_' + gid + ' div#xmpp_node_muc_activity_log_' + gid;
  var text = $(name).html();
  $(logname).slideToggle();
  if (text == 'Show') {
    $(name).html('Hide');
  } else {
    $(name).html('Show');
  }
}

/**
 * @param nid
 *      Node id that we will retrieve the information from
 * @param url
 *      Url where to go and get the information from
 * @param interval
 *      Time between AJAX block refreshes
 */
function xmpp_node_muc_refresh_block(nid, url, interval) {
  setTimeout(function() {
    $.get(url + '/' + nid, function(result) {
      // only try and do something if the result length we receive is larger than 0
      if (result.length > 0) {
        eval(result);
      };
      xmpp_node_muc_refresh_block(nid, url, interval); // continue with the block refreshing
    })
  }, interval);
}

/**
 * @param url
 *      Url of the xmpp client
 * @param username
 *      Username we will login as
 * @param resource
 *      Resource we will use when logged in
 * @param domain
 *      Domain we are logging into
 * @param srvUrl
 *      Server url for the client to send messages too
 * @param group
 *      Full jid of the group we wish to join
 * @param httpbase
 *      Base whether to use polling /http-poll/ or binding /http-bind/ interface
 * @param authtype
 *      Authtype whether to use SASL or NONSASL login
 * @param locale
 *      The locale to start the client with default is en
 * @param muc_conference
 *      The conference server for multi-user chat applications
 * @param search
 *      The service where all search requests will be sent too for the server
 */
function xmpp_node_muc_group_join(url, username, resource, domain, srvUrl, group, httpbase, authtype, locale, muc_conference, search) {
  w = window.open('', 'XMPPCLIENTROSTERWIN', ROSTERWINOPTS);
  w.blur();
  window.focus();
  if (w.con && w.con.connected()) {
    w.focus();
    w.xcMUCInviteLaunch(group, username);
  } else {
    w.close();
    // adding all the pertinent information needed in order to start the client
    url += '&username=' + username + '&resource=' + resource + '&domain=' + domain + '&srvUrl=' + escape(srvUrl) + '&muc=' + escape(group) + '&nickname=' + username;
    url += '&httpbase=' + httpbase + '&authtype=' + authtype + '&locale=' + locale + '&MUC=' + muc_conference + '&SEARCH=' + search;
    $.get(srvUrl + '/password', function(result) {
      xcpass = result;
      var w = window.open(url, 'XMPPCLIENTROSTERWIN', ROSTERWINOPTS);
      w.focus();
      result = '';
    });
  }
}

/**
 * @param data
 *      The information pertaining to the conversations
 */
function xmpp_node_muc_ajax_temporary_conversations_refresh(data) {
  // this is replacing the current content with the new content from the refresh
  $('.xmpp_node_muc_temporary_conversations').html(data);
}

/**
 * @param gid
 *      Group id being utilized
 * @param group_name
 *      Group name for the organic group
 * @param subject
 *      Current subject for the muc
 * @param online_status
 *      Online Status for the person in the group
 */
function xmpp_node_muc_ajax_group_info_refresh(gid, group_name, subject, online_status) {
  // setting the pertinent variables with the x-path for the elements we wish to alter
  var gname = '#xmpp_node_muc_group_list_' + gid + ' .xmpp_node_muc_group_list_item div#xmpp_node_muc_gid_' + gid + '.xmpp_node_muc_group_list_item_name div.name span.message';
  var sub = '#xmpp_node_muc_group_list_' + gid + ' .xmpp_node_muc_group_list_item div#xmpp_node_muc_gid_' + gid + '.xmpp_node_muc_group_list_item_name div.subject span.message';
  var ol = '#xmpp_node_muc_group_list_' + gid + ' .xmpp_node_muc_group_list_item div#xmpp_node_muc_gid_' + gid + '.xmpp_node_muc_group_list_item_name div.online span.message';
  var join_group = '#xmpp_node_muc_group_list_' + gid + ' .xmpp_node_muc_group_list_item div#xmpp_node_muc_gid_' + gid + '.xmpp_node_muc_group_list_item_name div.xmpp_node_muc_group_join';

  // this means that the current html there does not have the group id appended so we need to fix this
  if ($(gname).size() == 0) {
    // need to remove the old ones before putting the new ones in
    if ($('#xmpp_node_muc_group_list_').size() == 0) {
      $('.xmpp_node_muc_group_list_item_name').attr('id', 'xmpp_node_muc_gid_');
      $('.xmpp_node_muc_group_list').attr('id', 'xmpp_node_muc_group_list_');
    };
    $('#xmpp_node_muc_group_list_ .xmpp_node_muc_group_list_item div#xmpp_node_muc_gid_').attr('id', 'xmpp_node_muc_gid_' + gid);
    $('#xmpp_node_muc_group_list_').attr('id', 'xmpp_node_muc_group_list_' + gid);
  }

  $(gname).html(group_name);
  $(sub).html(subject);
  $(ol).html(online_status);
  if (online_status == 'Participating') {
    $(join_group).slideUp('slow');
  } else {
    $(join_group).slideDown('slow');
  }
}

/**
 * @param online
 *      Number of online users in the group
 * @param users
 *      Html to display the online users
 */
function xmpp_node_muc_ajax_online_muc_users_refresh(gid, online, users) {
  // setting the online muc users portions
  var name = '#xmpp_node_muc_online_count_' + gid + ' span.message';
  var title = '#xmpp_node_muc_online_count_' + gid + ' span.title';
  var ol = '#xmpp_node_muc_online_show_' + gid;
  var olu = '#xmpp_node_muc_online_users_' + gid;
  // checking if the element exists or not
  if ($(name).size() == 0) {
    // need to remove the old ones before putting the new ones in
    if ($('#xmpp_node_muc_online_').size() == 0) {
      $('.xmpp_node_muc_online_user').remove();
      $('.xmpp_node_muc_online_users').attr('id', 'xmpp_node_muc_online_users_');
      $('.xmpp_node_muc_online_show a').attr('href', 'javascript:xmpp_node_muc_online_users_toggle(\'\');');
      $('.xmpp_node_muc_online_show').attr('id', 'xmpp_node_muc_online_show_');
      $('.xmpp_node_muc_online_count').attr('id', 'xmpp_node_muc_online_count_');
      $('.xmpp_node_muc_online').attr('id', 'xmpp_node_muc_online_');
    };
    $('#xmpp_node_muc_online_show_ a').attr('href', 'javascript:xmpp_node_muc_online_users_toggle(\'' + gid + '\');');
    $('#xmpp_node_muc_online_count_').attr('id', 'xmpp_node_muc_online_count_' + gid);
    $('#xmpp_node_muc_online_show_').attr('id', 'xmpp_node_muc_online_show_' + gid);
    $('#xmpp_node_muc_online_users_').attr('id', 'xmpp_node_muc_online_users_' + gid);
    $('#xmpp_node_muc_online_').attr('id', 'xmpp_node_muc_online_' + gid);
  }

  $(name).html(online);
  if (online == 0) {
    $(title).html('Online Users:');
    $(ol).hide();
    $(olu).html('');
  } else {
    $(title).html('Active Participants:');
    $(ol).show();
    $(olu).html(users);
  }
}

/**
 * @param gid
 *      Group id for the group
 * @param mdate
 *      Last message date if there is one
 * @param logs
 *      MUC Logs for the system
 */
function xmpp_node_muc_ajax_muc_log_refresh(gid, mdate, logs) {
  var name = '#xmpp_node_muc_activity_' + gid + ' div#xmpp_node_muc_activity_last_' + gid + ' span.message';
  var logname = '#xmpp_node_muc_activity_' + gid + ' div#xmpp_node_muc_activity_log_' + gid;
  var activity = '#xmpp_node_muc_activity_' + gid + ' div#xmpp_node_muc_activity_show_' + gid;
  // checking if the element exists or not
  if ($(name).size() == 0) {
    // need to remove the old ones before putting the new ones in
    if ($('#xmpp_node_muc_activity_').size() == 0) {
      $('.xmpp_node_muc_activity_log').attr('id', 'xmpp_node_muc_activity_log_');
      $('.xmpp_node_muc_activity_show a').attr('href', 'javascript:xmpp_node_muc_activity_msgs_toggle(\'\');');
      $('.xmpp_node_muc_activity_show').attr('id', 'xmpp_node_muc_activity_show_');
      $('.xmpp_node_muc_activity_last').attr('id', 'xmpp_node_muc_activity_last_');
      $('.xmpp_node_muc_activity').attr('id', 'xmpp_node_muc_activity_');
    };
    $('#xmpp_node_muc_activity_ div#xmpp_node_muc_activity_last_').attr('id', 'xmpp_node_muc_activity_last_' + gid);
    $('#xmpp_node_muc_activity_ div#xmpp_node_muc_activity_log_').attr('id', 'xmpp_node_muc_activity_log_' + gid);
    $('#xmpp_node_muc_activity_ div#xmpp_node_muc_activity_show_ a').attr('href', 'javascript:xmpp_node_muc_activity_msgs_toggle(\'' + gid + '\');');
    $('#xmpp_node_muc_activity_ div#xmpp_node_muc_activity_show_').attr('id', 'xmpp_node_muc_activity_show_' + gid);
    $('#xmpp_node_muc_activity_').attr('id', 'xmpp_node_muc_activity_' + gid);
  }

  $(name).html(mdate);
  $(logname).html(logs);
  if (mdate == 'Never') {
    $(activity).hide();
  } else {
    $(activity).show();
  }
}

